﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace 播放器
{
    public partial class 小强播放器 : Form
    {
        List<string> Songs=new List<string>();
        int songID=0;    //播放歌曲序号，默认0
        public 小强播放器()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            myPlayer.settings.autoStart = false;
        }

        private void btnPP_Click(object sender, EventArgs e) //播放暂停按钮
        {
            //if (btnPP.Text == "播放")                        //如果按钮显示播放，那么点击将开始播放，并且按钮的text变成暂停
            //{
                
            //    myPlayer.Ctlcontrols.play();
            //    btnPP.Text = "暂停";

            //}
            //else if (btnPP.Text == "暂停")                        //如果按钮显示暂停，那么点击将暂停播放，并且按钮的text变成播放
            //{
               
            //    myPlayer.Ctlcontrols.pause(); 
            //    btnPP.Text = "播放";

            //}
            switch (btnPP.Text)
            { 
                case "播放":
                    myPlayer.Ctlcontrols.play();
                    btnPP.Text = "暂停";
                    btnStop.Enabled = true;
                    btnmute.Enabled = true;
                    break;
                case "暂停":
                    myPlayer.Ctlcontrols.pause();
                    btnPP.Text = "播放";
                    break;
                default:
                    break;
            }
        }

        private void btnAddurl_Click(object sender, EventArgs e) //添加MP3文件
        {
            OpenFileDialog OFD = new OpenFileDialog();
            OFD.Filter = "音乐文件|*.mp3;*.wma";
            OFD.Multiselect = true;
            if (OFD.ShowDialog() == DialogResult.OK)
            {
                Songs.Clear();
                listSongs.Items.Clear();
                for (int i = 0; i < OFD.FileNames.Length; i++)
                {
                    Songs.Add(OFD.FileNames[i]);
                    string[] temp = OFD.FileNames[i].Split('\\');
                    listSongs.Items.Add(temp[temp.Length - 1]);
                }
                初始化按钮();
                if (Songs.Count > 1)         //如果歌曲列表歌曲数目大于1首，那么使得上一曲 下一曲按钮有效，否则失效
                {
                    btnNext.Enabled = true;
                    btnUp.Enabled = true;
                }
                Play();

            }            
        }

        private void btnStop_Click(object sender, EventArgs e) //停止按钮
        {
            myPlayer.Ctlcontrols.stop();
            btnStop.Enabled = false;
            btnmute.Enabled = false;
            btnmute.Text = "静音";
            myPlayer.settings.mute = false;
            btnPP.Text = "播放";
        }

        private void btnmute_Click(object sender, EventArgs e)//静音按钮
        {
            myPlayer.settings.mute = (myPlayer.settings.mute == true)?false:true;
            if (myPlayer.settings.mute == true)
            {
                btnmute.Text = "取消静音";
            }
            else
            {
                btnmute.Text = "静音";
            }
        }
        void 初始化按钮()
        {
            btnPP.Text = "播放";
            btnmute.Text = "静音";
            btnmute.Enabled = true;
            btnStop.Enabled = true;
            btnPP.Enabled = true;
        }
        void Play(int i)
        {
            myPlayer.URL = Songs[i];
            listSongs.SelectedIndex = i;
            myPlayer.Ctlcontrols.play();
            btnPP.Text = "暂停";

        }//播放方法
        //void Playnext(int i)
        //{   
        //    foreach (var item in Songs)
        //    {
        //        var songItem = myPlayer.newMedia(item);
        //        myPlayer.currentPlaylist.appendItem(songItem);
        //    }
        //    myPlayer.Ctlcontrols.play();
        //    if (listSongs.SelectedIndex < Songs.Count - 1)
        //    {
        //        listSongs.SelectedIndex++;
        //    }
        //    else
        //    {
        //        listSongs.SelectedIndex = 0;
        //    }
        //}
        void Play()      //没有指定播放序号，默认播放第一首
        {
            Play(0);
        }

        private void btnUp_Click(object sender, EventArgs e)  //上一曲，获取当前播放歌曲的序号，序号大于0，表示前面至少有一首歌，那么序号减1， 
        {                                                     //如果序列=0，表示当前播放的是第一首歌，那么点上一曲跳转到最后一曲
            songID = listSongs.SelectedIndex;
            songID = songID > 0 ? --songID : Songs.Count-1;
            初始化按钮();
            Play(songID);

        }

        private void btnNext_Click(object sender, EventArgs e) //下一曲 获取当前播放歌曲序号，序号小于歌曲列表最后一首歌的序号，那么点下一曲，
        {                                                      //序号+1，反之，则表示当前播放的是最后一首歌，那下一曲跳到第一首
            songID = listSongs.SelectedIndex;
            songID = songID < Songs.Count - 1 ? ++songID : 0;
            初始化按钮();
            Play(songID);

        }

        private void listSongs_MouseDoubleClick(object sender, MouseEventArgs e)//鼠标双击选择列表歌曲进行播放
        {
            初始化按钮();
            Play(listSongs.SelectedIndex);
         
        }

        private void delToolStripMenuItem_Click(object sender, EventArgs e)   //右键  删除
        {
            if (listSongs.SelectedIndex!=-1)
            {
                Songs.RemoveAt(listSongs.SelectedIndex);
                listSongs.Items.RemoveAt(listSongs.SelectedIndex);
            }
            if(Songs.Count==0)
            {
                btnUp.Enabled = false;
                btnNext.Enabled = false;
            }

        }

        private void dropToolStripMenuItem_Click(object sender, EventArgs e)   //右键  清空
        {
            Songs.Clear();
            listSongs.Items.Clear();
            btnUp.Enabled = false;
            btnNext.Enabled = false;
        }

        private void myPlayer_PlayStateChange(object sender, AxWMPLib._WMPOCXEvents_PlayStateChangeEvent e)
        {

            if (myPlayer.playState == WMPLib.WMPPlayState.wmppsMediaEnded)
            {

                int temp = listSongs.SelectedIndex;
                temp++;
                if (temp > Songs.Count - 1)
                {

                    listSongs.SelectedIndex = 0;
                    myPlayer.URL = Songs[0];


                }
                else
                {
                    listSongs.SelectedIndex = temp;
                    myPlayer.URL = Songs[temp];

                }
            }
            if (myPlayer.playState == WMPLib.WMPPlayState.wmppsReady)
            {
                //myPlayer.Ctlcontrols.play();  //注释掉这句就没问题了
            }

        }
    }
}
